﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridHashSetTest
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        public Form1()
        {
            InitializeComponent();

            HashSet<Parent> data = new HashSet<Parent>();

            for(int i=0; i<10; i++)
            {
                Parent sd = new Parent() { ID = i, Number = r.Next(1000) };
                sd = new Parent() { ID = i, Number = r.Next(1000) };

                for(int j=0; j<4; j++)
                {
                    sd.Children.Add(new ParentChild() { ChildID = j, ChildNumber = r.Next(1000)});
                }

                data.Add(sd);
            }

            ultraGrid1.DataSource = data;
        }
    }

    public partial class Parent
    {
        public int ID { get; set; }
        public int Number { get; set; }

        public virtual ICollection<ParentChild> Children { get; set; }

        public Parent()
        {
            Children = new HashSet<ParentChild>();
        }
    }

    public partial class ParentChild
    {
        public int ChildID { get; set; }
        public int ChildNumber { get; set; }        
        public virtual Parent Parent { get; set; }
    }
}
